<?php
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );
/**
* @version $Id: ps_twocheckout.php,v 1.4 2005/01/27 19:33:57 soeren_nb Exp $
* @package mambo-phpShop
* @subpackage Payment
* @copyright (C) 2004-2005 Soeren Eberhardt
*
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* mambo-phpShop is Free Software.
* mambo-phpShop comes with absolute no warranty.
*
* www.mambo-phpshop.net
*
* The ps_twocheckout class, containing the payment processing code
*  for transactions with 2Checkout 
 */

class ps_twocheckout {

    var $payment_code = "TWOCO";
    var $classname = "ps_twocheckout";
  
    /**
    * Show all configuration parameters for this payment method
    * @returns boolean False when the Payment method has no configration
    */
    function show_configuration() { 
    
      global $PHPSHOP_LANG;
      /** Read current Configuration ***/
      require_once(CLASSPATH ."payment/".$this->classname.".cfg.php");
    ?>
      <table>
        <tr>
            <td><strong><?php echo $PHPSHOP_LANG->_PHPSHOP_ADMIN_CFG_ENABLE_AUTORIZENET_TESTMODE ?></strong></td>
            <td>
                <select name="TWOCO_TEST_REQUEST" class="inputbox" >
                <option <? if (TWOCO_TEST_REQUEST == 'Y') echo "selected=\"selected\""; ?> value="Y"><?php echo $PHPSHOP_LANG->_PHPSHOP_ADMIN_CFG_YES ?></option>
                <option <? if (TWOCO_TEST_REQUEST == 'N') echo "selected=\"selected\""; ?> value="N"><?php echo $PHPSHOP_LANG->_PHPSHOP_ADMIN_CFG_NO ?></option>
                </select>
            </td>
            <td><?php echo $PHPSHOP_LANG->_PHPSHOP_ADMIN_CFG_ENABLE_AUTORIZENET_TESTMODE_EXPLAIN ?>
            </td>
        </tr>
        <tr>
            <td><strong>2Checkout.com Seller id</strong></td>
            <td>
                <input type="text" name="TWOCO_LOGIN" class="inputbox" value="<? echo TWOCO_LOGIN ?>" />
            </td>
            <td>Your 2Checkout.com Seller id
            </td>
        </tr>
        <tr>
            <td><strong>Merchant Notifications</strong></td>
            <td>
                <select name="TWOCO_MERCHANT_EMAIL" class="inputbox" >
                  <option <? if (TWOCO_MERCHANT_EMAIL == 'True') echo "selected=\"selected\""; ?> value="True"><?php echo $PHPSHOP_LANG->_PHPSHOP_ADMIN_CFG_YES ?></option>
                  <option <? if (TWOCO_MERCHANT_EMAIL == 'False') echo "selected=\"selected\""; ?> value="False"><?php echo $PHPSHOP_LANG->_PHPSHOP_ADMIN_CFG_NO ?></option>
                </select>
            </td>
            <td>Should 2CheckOut e-mail a receipt to the store owner?
            </td>
        </tr>
      </table>
   <?php
      // return false if there's no configuration
      return true;
   }
   
    function has_configuration() {
      // return false if there's no configuration
      return true;
   }
   
  /**
	* Returns the "is_writeable" status of the configuration file
	* @param void
	* @returns boolean True when the configuration file is writeable, false when not
	*/
   function configfile_writeable() {
      return is_writeable( CLASSPATH."payment/".$this->classname.".cfg.php" );
   }
   
  /**
	* Returns the "is_readable" status of the configuration file
	* @param void
	* @returns boolean True when the configuration file is writeable, false when not
	*/
   function configfile_readable() {
      return is_readable( CLASSPATH."payment/".$this->classname.".cfg.php" );
   }   
  /**
	* Writes the configuration file for this payment method
	* @param array An array of objects
	* @returns boolean True when writing was successful
	*/
   function write_configuration( &$d ) {
      
      $my_config_array = array("TWOCO_TEST_REQUEST" => $d['TWOCO_TEST_REQUEST'],
                                              "TWOCO_LOGIN" => $d['TWOCO_LOGIN'],
                                              "TWOCO_MERCHANT_EMAIL" => $d['TWOCO_MERCHANT_EMAIL']
                                      );
      $config = "<?php\n";
      $config .= "defined('_VALID_MOS') or die('Direct Access to this location is not allowed.'); \n\n";
      foreach( $my_config_array as $key => $value ) {
        $config .= "define ('$key', '$value');\n";
      }
      
      $config .= "?>";
  
      if ($fp = fopen(CLASSPATH ."payment/".$this->classname.".cfg.php", "w")) {
          fputs($fp, $config, strlen($config));
          fclose ($fp);
          return true;
     }
     else
        return false;
   }
   
  /**************************************************************************
  ** name: process_payment()
  ** created by: soeren
  ** description: process transaction for 2Checkout in authorize.net-compatibility mode
  ** parameters: $order_number, the number of the order, we're processing here
  **            $order_total, the total $ of the order
  ** returns: 
  ***************************************************************************/
   function process_payment($order_number, $order_total, &$d) {
      $ps_vendor_id = $_SESSION["ps_vendor_id"];
      $auth = $_SESSION['auth'];
      $ps_checkout = new ps_checkout;
      
      /*** Get the Configuration File for authorize.net ***/
      require_once(CLASSPATH ."payment/".$this->classname.".cfg.php");
      
       // Get user billing information
       $dbbt = new ps_DB;
       $qt = "SELECT * from #__users ";
       $qt .= "WHERE id='".$auth["user_id"]."' ";
       $qt .= "AND address_type='BT'";
       $dbbt->query($qt);
       $dbbt->next_record();     

       $host = "www.2checkout.com";
       $port = 443;
       $path = "/cgi-bin/Abuyers/purchase.2c";
  
       //Authnet vars to send
       $formdata = array (
         'x_version' => '3.1',
         'x_delim_data' => 'True',
         'x_delim_char' => '|',
         'x_relay_response' => 'False',
         'x_login' => TWOCO_LOGIN,
         'x_test_request' => TWOCO_TEST_REQUEST,
         'x_email_merchant' => ((TWOCO_MERCHANT_EMAIL == 'True') ? 'TRUE' : 'FALSE'),
         
         'x_first_name' => $dbbt->f("first_name"),
         'x_last_name' => $dbbt->f("last_name"),
         'x_address' => $dbbt->f("address_1"),
         'x_city' => $dbbt->f("city"),
         'x_state' => $dbbt->f("state"),
         'x_zip' => $dbbt->f("zip"),
         'x_country' => $dbbt->f("country"),
         'x_card_num' => $_SESSION['ccdata']['order_payment_number'],
         'x_card_code' => '',
         'x_amount' => $ps_checkout->get_vendor_currency($ps_vendor_id) . " " . $order_total,
  
         'x_exp_date' => ($_SESSION['ccdata']['order_payment_expire_month']) . ($_SESSION['ccdata']['order_payment_expire_year']),
         'x_email' => '',
         'x_email_customer' => 'False',
         'x_cust_id' => '',
         'x_customer_ip' => $_SERVER["REMOTE_ADDR"],
         'x_phone' => '',
         'x_fax' => '',
         'x_invoice_num' => $order_number,
         'x_description' => ''
       );

      //build the post string
       $poststring = '';
       foreach($formdata AS $key => $val){
         $poststring .= urlencode($key) . "=" . urlencode($val) . "&";
       }
       // strip off trailing ampersand
       $poststring = substr($poststring, 0, -1);
   
       $fp = fsockopen("ssl://".$host, $port, $errno, $errstr, $timeout = 60);
  
      if(!$fp){
        //error tell us
        echo "$errstr ($errno)\n";
      }
       else {

         //send the server request
         fputs($fp, "POST $path HTTP/1.1\r\n");
         fputs($fp, "Host: $host\r\n");
         fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
         fputs($fp, "Content-length: ".strlen($poststring)."\r\n");
         fputs($fp, "Connection: close\r\n\r\n");
         fputs($fp, $poststring . "\r\n\r\n");
  
         //Get the response header from the server
         $str = '';
         while(!feof($fp) && !stristr($str, 'content-length')) {
           $str = fgets($fp, 4096);
         }
         // If didnt get content-lenght, something is wrong, return false.
         if (!stristr($str, 'content-length')) {
           return false;
         }
         // Get length of data to be received.
         $length = trim(substr($str,strpos($str,'content-length') + 15));
         // Get buffer (blank data before real data)
         fgets($fp, 4096);
         // Get real data
         $data = fgets($fp, $length);
         fclose($fp);
         $response = explode("|", $data);
      }

     $d["order_payment_log"] = "";
     
     if ($response[0] == '1') {
       return True;
     } 
     else {
       $d["error"] = $response[3];
       return False;
     }
   }
   

   
}
